<!-- toggle -->
<div (click)="toggle()" class="app-toggle">
  <!-- switch type -->
  <ng-container [ngSwitch]="type">
    <!-- device -->
    <ng-container *ngSwitchCase="'device'">
      <!-- lock -->
      <app-icon-lock></app-icon-lock>
    </ng-container>

    <!-- space -->
    <ng-container *ngSwitchCase="'space'">
      <!-- package -->
      <app-icon-package></app-icon-package>
    </ng-container>

    <!-- keyholder -->
    <ng-container *ngSwitchCase="'keyholder'">
      <!-- mobile -->
      <app-icon-mobile></app-icon-mobile>
    </ng-container>
  </ng-container>

  <!-- count -->
  +{{ associations.length }}
</div>

<!-- associations -->
<app-card
  [ngClass]="typeCheck ? 'device-association' : 'space-association'"
  (outsideClick)="close()"
  *ngIf="opened"
  [(verticalPriority)]="vertical"
  [outsideDetectorContainer]="elementRef"
  [positionDetectorContainer]="elementRef"
  appOutsideDetector
  appPositionDetector
  class="app-associations"
>
  <!-- association header -->
  <div class="app-header">
    <!-- title -->
    <app-card-title> ASSOCIATED {{ type | uppercase }}S </app-card-title>

    <!-- count -->
    <div class="app-count">
      {{ associations.length }}
    </div>
  </div>

  <!-- content -->
  <app-custom-scrollbar class="app-content">
    <!-- render items -->
    <ng-container *ngFor="let item of associations">
      <!-- item -->
      <div class="app-association-item">
        <!-- switch by type -->
        <ng-container [ngSwitch]="type">
          <!-- device -->
          <ng-container *ngSwitchCase="'device'">
            <!-- lock -->
            <app-icon-lock></app-icon-lock>

            <!-- right -->
            <div class="app-right">
              <!-- name -->
              <div class="app-name">
                {{ item.name }}
              </div>

              <!-- state -->
              <app-state-label [state]="item.state" type="device"></app-state-label>
            </div>
          </ng-container>

          <!-- space -->
          <ng-container *ngSwitchCase="'space'">
            <!-- package -->
            <app-icon-package></app-icon-package>

            <!-- right -->
            <div class="app-right">
              <!-- name -->
              <div class="app-name">
                {{ item.name }}
              </div>

              <!-- state -->
              <app-state-label [state]="item.state" type="space"></app-state-label>
            </div>
          </ng-container>

          <!-- keyholder -->
          <ng-container *ngSwitchCase="'keyholder'">
            <!-- user info -->
            <app-user-info [user]="item" type="custom">
              <!-- state label -->
              <app-state-label [state]="item.state" custom type="keyholder"></app-state-label>
            </app-user-info>
          </ng-container>
        </ng-container>
      </div>
    </ng-container>
  </app-custom-scrollbar>

  <!-- footer -->
  <div *ngIf="!readOnly" class="app-footer">
    <!-- switch by type -->
    <ng-container [ngSwitch]="type">
      <!-- device -->
      <ng-container *ngSwitchCase="'device'">
        <button (click)="emitAddClick()" appOutlinedButton theme="secondary">
          <app-icon-mobile></app-icon-mobile>
          Add/Remove A Device
        </button>
      </ng-container>

      <!-- space -->
      <ng-container *ngSwitchCase="'space'">
        <button (click)="emitAddClick()" appOutlinedButton theme="secondary">
          <app-icon-package></app-icon-package>
          Add/Remove A Space
        </button>
      </ng-container>

      <!-- keyholder -->
      <ng-container *ngSwitchCase="'keyholder'">
        <button (click)="emitAddClick()" appOutlinedButton theme="secondary">
          <app-icon-package></app-icon-package>
          Add/Remove A Keyholder
        </button>
      </ng-container>
    </ng-container>
  </div>
</app-card>
